import { describe, test, it, expect } from 'vitest'
import {RuntimeConfig} from "@nuxt/schema";
import {AnyAbility} from "@casl/ability/dist/types";
import {AccessProfile, organizationState} from "~/types/interfaces";
import AgendaMenuBuilder from "~/services/layout/menuBuilder/agendaMenuBuilder";
import {MenuGroup} from "~/types/layout";
import {MENU_LINK_TYPE} from "~/types/enum/layout";

let runtimeConfig: RuntimeConfig
let ability: AnyAbility
let organizationProfile: organizationState
let accessProfile: AccessProfile
let menuBuilder: AgendaMenuBuilder

beforeEach(()=> {
    runtimeConfig = vi.fn() as any as RuntimeConfig
    ability = vi.fn() as any as AnyAbility
    organizationProfile = vi.fn() as any as organizationState
    accessProfile = vi.fn() as any as AccessProfile

    runtimeConfig.baseUrlAdminLegacy = 'https://mydomain.com/'

    menuBuilder = new AgendaMenuBuilder(runtimeConfig, ability, organizationProfile, accessProfile)
})


describe('getMenuName', () => {
    test('validate name', () => {
        expect(menuBuilder.getMenuName()).toEqual("Agenda")
    })
})


describe('build', () => {
    test('has all items', () => {
        ability.can = vi.fn(() => true)

        // Should return a MenuGroup
        const result = menuBuilder.build() as MenuGroup

        expect(result.label).toEqual('schedule')
        expect(result.icon).toEqual({name: 'fas fa-calendar-alt'})
        // @ts-ignore
        expect(result.children.length).toEqual(2)
    })

    test('has no items', () => {
        ability.can = vi.fn(() => false)
        expect(menuBuilder.build()).toEqual(null)
    })

    test('has only rights for menu schedule', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'agenda_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'schedule', icon: {name: 'fas fa-calendar-alt'}, to: 'https://mydomain.com/calendar', type: MENU_LINK_TYPE.V1, active: false}
        )
    })

    test('has only rights for menu attendances', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'attendance_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'attendances', icon: {name: 'fas fa-calendar-check'}, to: 'https://mydomain.com/attendances/list/', type: MENU_LINK_TYPE.V1, active: false}
        )
    })
})
